/*--------------------------------------------------------------*/
//File:	LCD1602_8A.H
//Time:	20:10
//Modi:	09-5-17


/*--------------------------------------------------------------*/ 
//ֹظ
#ifndef __LCD1602_8A_H__			
#define __LCD1602_8A_H__


/*--------------------------------------------------------------*/ 
//ģʽѡ()
#define Port_Type_Select	0	//=1, ѡλģʽ
								//=0, ѡλģʽ, LCDλMCU˿ڵλ
								//=2, ѡλģʽ, LCDλMCU˿ڸλ



/*--------------------------------------------------------------*/
//LCD1602ӿڶ
#if   (Port_Type_Select == 1)	//ѡλģʽ
#define LCD_DMASK	0xff
#elif (Port_Type_Select == 0)	//ѡλģʽ(λ)
#define LCD_DMASK	0x0f
#elif (Port_Type_Select == 2)	//ѡλģʽ(λ)
#define LCD_DMASK	0xf0
#endif

#define LCD_IN  P_IN(C, LCD_DMASK)	//
#define LCD_OUT P_OUT(C, LCD_DMASK)	//
#define LCD_RS	PORT(B, 3)			//ָ		//LCD/ѡ(H/L)
#define LCD_RW	PORT(B, 4)			//дƶ	//LCD  /д  ѡ(H/L)
#define LCD_EN	PORT(B, 5)			//ʹܶ		//LCD ʹܿƶ



/*--------------------------------------------------------------*/
//ʽ
#define LCD_DISPLAY8_DOUBLE_LINE	LCD_cmd(0x38);	//ʾ8-bits
#define LCD_DISPLAY8_SINGLE_LINE	LCD_cmd(0x30);	//ʾ8-bits
#define LCD_DISPLAY4_DOUBLE_LINE	LCD_cmd(0x28);	//ʾ4-bits
#define LCD_DISPLAY4_SINGLE_LINE	LCD_cmd(0x20);	//ʾ4-bits


/*--------------------------------------------------------------*/
//뷽ʽ
#define LCD_AC_AUTO_INCREMENT	LCD_cmd(0x06);	//ݶд,ACԶ 1
#define LCD_AC_AUTO_DECREASE	LCD_cmd(0x04);	//ݶд,ACԶ 1
#define LCD_MOVE_ENABLE			LCD_cmd(0x07);	//ݶд,ƽ
#define LCD_MOVE_DISENABLE		LCD_cmd(0x06);	//ݶд,治



/*--------------------------------------------------------------*/
//ʾ꼰˸
#define LCD_DISPLAY_ON 			LCD_cmd(0x0c);	//LCDʾ
#define LCD_DISPLAY_OFF 		LCD_cmd(0x08);	//LCDʾ
#define LCD_CURSOR_ON			LCD_cmd(0x0e);	//ʾ
#define LCD_CURSOR_OFF			LCD_cmd(0x0c);	//겻ʾ
#define LCD_CURSOR_BLINK_ON		LCD_cmd(0x0f);	//˸
#define LCD_CURSOR_BLINK_OFF	LCD_cmd(0x0e);	//겻˸

#define LCD_GO_HOME				LCD_cmd(0x02);	//AC=0,ꡢHOMEλ, DDRAMݲ
#define LCD_CLR					LCD_cmd(0x01);	//LCD, DDRAM, Ļ, ACΪ0, λ



/*--------------------------------------------------------------*/
//ꡢƶ,ӰDDRAM
#define LCD_LEFT_MOVE			LCD_cmd(0x18);	//LCDʾһλ
#define LCD_RIGHT_MOVE			LCD_cmd(0x1c);	//LCDʾһλ
#define LCD_CURSOR_LEFT_MOVE	LCD_cmd(0x10);	//һλ
#define LCD_CURSOR_RIGHT_MOVE	LCD_cmd(0x14);	//һλ



/*--------------------------------------------------------------*/
//LCD1602ַ
/*
#define LINE1_HEAD		0x80		//һDDRAMʼַ
#define LINE2_HEAD		0xc0		//ڶDDRAMʼַ
#define LINE1			0			//һ
#define LINE2			1			//ڶ
#define LINE_LENGTH		16			//ÿеַ(40-DDRAM)
*/


/*--------------------------------------------------------------*/ 
//
void LCD_busy  (void);													//LCDǷæ
void LCD_init  (void);													//LCDʼ
void LCD_cmd   (unsigned char cmd);										//дָ
void LCD_dat   (unsigned char dat);										//д
void LCD_pos   (unsigned char x, unsigned char y);						//ʾλ
void LCD_printc(unsigned char x, unsigned char y, unsigned char c);		//λַ
void LCD_prints(unsigned char x, unsigned char y, unsigned char *s);	//λַ
void LCD_printn(unsigned char x, unsigned char y, unsigned int num, unsigned char num_bit);	//λ16λ

unsigned char LCD_current_addr(void);									//ACǰַ(DB6~DB0)æ־λDB7
unsigned char LCD_current_addr_dat(void);								//ACǰַ
unsigned char LCD_addr_dat(unsigned char x, unsigned char y);			//ACַָ
void LCD_pos_CG(unsigned char x, unsigned char *CGRAM_dat);				//ַָ(x: 0-7)д8bytesCGRAM


/*--------------------------------------------------------------*/ 
//ACǰַ(DB6~DB0)æ־λDB7
#if (Port_Type_Select == 1)	//ѡλģʽ
unsigned char LCD_current_addr(void)
{
	unsigned char ac_addr;

	LCD_EN = 0;
	LCD_RS = 0;				//ָ
	LCD_RW = 1;				//
	LCD_EN = 1;
	ac_addr = LCD_IN;
	LCD_EN = 0;

	return (ac_addr);
}

#elif (Port_Type_Select == 0)//ѡλģʽ(λ)
unsigned char LCD_current_addr(void)
{
	unsigned char ac_addr;

	LCD_EN = 0;
	LCD_RS = 0;				//ָ
	LCD_RW = 1;				//

	LCD_EN = 1;
	ac_addr = LCD_IN;		//λ
	LCD_EN = 0;
	
	ac_addr <<= 4;
	LCD_EN = 1;
	ac_addr |= LCD_IN;		//λ
	LCD_EN = 0;

	return (ac_addr);
}

#elif (Port_Type_Select == 2)//ѡλģʽ(λ)
unsigned char LCD_current_addr(void)
{
	unsigned char ac_addr;

	LCD_EN = 0;
	LCD_RS = 0;				//ָ
	LCD_RW = 1;				//

	LCD_EN = 1;
	ac_addr = LCD_IN;		//λ
	LCD_EN = 0;
	
	LCD_EN = 1;
	ac_addr |= (LCD_IN >> 4);//λ
	LCD_EN = 0;

	return (ac_addr);
}
#endif


/*--------------------------------------------------------------*/ 
//LCDæ״̬	
void LCD_busy(void)
{
	unsigned char ac_dat;
	unsigned char busy_flag;

	do
	{
		ac_dat = LCD_current_addr();
		busy_flag = ac_dat & 0x80;
	}while(busy_flag);		//=1ʾæ, =0ʾ
}


/*--------------------------------------------------------------*/ 
//ACǰַ
#if (Port_Type_Select == 1)	//ѡλģʽ
unsigned char LCD_current_addr_dat(void)
{
	unsigned char addr_dat;
	LCD_busy();				//æɿ
	LCD_EN = 0;
	LCD_RS = 1;				//
	LCD_RW = 1;				//
	LCD_EN = 1;
	addr_dat = LCD_IN;
	LCD_EN = 0;

	return (addr_dat);
}

#elif (Port_Type_Select == 0)//ѡλģʽ(λ)
unsigned char LCD_current_addr_dat(void)
{
	unsigned char addr_dat;

	LCD_busy();				//æɿ

	LCD_EN = 0;
	LCD_RS = 1;				//
	LCD_RW = 1;				//

	LCD_EN = 1;
	addr_dat = LCD_IN;		//λ
	LCD_EN = 0;

	addr_dat <<= 4;
	LCD_EN = 1;
	addr_dat |= LCD_IN;		//λ
	LCD_EN = 0;

	return (addr_dat);
}

#elif (Port_Type_Select == 2)//ѡλģʽ(λ)
unsigned char LCD_current_addr_dat(void)
{
	unsigned char addr_dat;

	LCD_busy();				//æɿ

	LCD_EN = 0;
	LCD_RS = 1;				//
	LCD_RW = 1;				//

	LCD_EN = 1;
	addr_dat = LCD_IN;		//λ
	LCD_EN = 0;

	LCD_EN = 1;
	addr_dat |= (LCD_IN >> 4);//λ
	LCD_EN = 0;

	return (addr_dat);
}
#endif


/*--------------------------------------------------------------*/ 
//дָ
#if (Port_Type_Select == 1)	//ѡλģʽ
void LCD_cmd(unsigned char cmd)
{
	LCD_busy();				//æ
	LCD_RS = 0;				//ָ
	LCD_RW = 0;				//д
	LCD_EN = 1;
	LCD_OUT = cmd;			//ָ
	LCD_EN = 0;				//½Ч
}

#elif (Port_Type_Select == 0)//ѡλģʽ(λ)
void LCD_cmd(unsigned char cmd)
{
	LCD_busy();				//æ

	LCD_OUT &= 0xf0;		//λ
	LCD_RS = 0;				//ָ
	LCD_RW = 0;				//д
	LCD_EN = 1;
	LCD_OUT |= ((cmd & 0xf0) >> 4);	//дλ
	LCD_EN = 0;				//½Ч

	LCD_OUT &= 0xf0;		//λ
	LCD_EN = 1;
	LCD_OUT |= cmd & 0x0f;	//дλ
	LCD_EN = 0;				//½Ч
}

#elif (Port_Type_Select == 2)//ѡλģʽ(λ)
void LCD_cmd(unsigned char cmd)
{
	LCD_busy();				//æ

	LCD_OUT &= 0x0f;		//λ
	LCD_RS = 0;				//ָ
	LCD_RW = 0;				//д
	LCD_EN = 1;
	LCD_OUT |= (cmd & 0xf0);//дλ
	LCD_EN = 0;				//½Ч

	LCD_OUT &= 0x0f;		//λ
	LCD_EN = 1;
	LCD_OUT |= (cmd << 4);	//дλ
	LCD_EN = 0;				//½Ч
}
#endif


/*--------------------------------------------------------------*/ 
//д
#if (Port_Type_Select == 1)	//ѡλģʽ
void LCD_dat(unsigned char dat)
{
	LCD_busy();				//æ
	LCD_RS = 1;				//
	LCD_RW = 0;				//д
	LCD_EN = 1;
	LCD_OUT = dat;			//
	LCD_EN = 0;				//½Ч
}

#elif (Port_Type_Select == 0)//ѡλģʽ(λ)
void LCD_dat(unsigned char dat)
{
	LCD_busy();				//æ

	LCD_OUT &= 0xf0;		//λ
	LCD_RS = 1;				//
	LCD_RW = 0;				//д
	LCD_EN = 1;
	LCD_OUT |= ((dat & 0xf0) >> 4);	//дλ
	LCD_EN = 0;				//½Ч

	LCD_OUT &= 0xf0;		//λ
	LCD_EN = 1;
	LCD_OUT |= dat & 0x0f;	//дλ
	LCD_EN = 0;				//½Ч
}

#elif (Port_Type_Select == 2)//ѡλģʽ(λ)
void LCD_dat(unsigned char dat)
{
	LCD_busy();				//æ

	LCD_OUT &= 0x0f;		//λ
	LCD_RS = 1;				//
	LCD_RW = 0;				//д
	LCD_EN = 1;
	LCD_OUT |= (dat & 0xf0);//дλ
	LCD_EN = 0;				//½Ч

	LCD_OUT &= 0x0f;		//λ
	LCD_EN = 1;
	LCD_OUT |= (dat << 4);	//дλ
	LCD_EN = 0;				//½Ч
}
#endif


/*--------------------------------------------------------------*/ 
//ʾλDDRAM
void LCD_pos(unsigned char x, unsigned char y)
{
	if(y)	LCD_cmd(x|0xc0);	//y=1ڶʾ,y=0һʾ	0<=x<16(40-DDRAM)
	else	LCD_cmd(x|0x80);	//ָ=80+ַ(00H~27H,40H~67H)
}


/*--------------------------------------------------------------*/ 
//ַָ(x: 0-7)д8bytesCGRAM
void LCD_pos_CG(unsigned char x, unsigned char *CGRAM_dat)
{
	unsigned char i;
		
	x <<= 3;				//תΪ6λݵĸλ
	x |=  0x40;
	LCD_cmd(x);				//дַ
	for(i = 0; i < 8; i++)	
	LCD_dat(CGRAM_dat[i]);	//д
}


/*--------------------------------------------------------------*/ 
//ACַָ
unsigned char LCD_addr_dat(unsigned char x, unsigned char y)
{
	unsigned char addr_dat;
	
	LCD_pos(x, y);						//λ
	addr_dat = LCD_current_addr_dat();	//

	return (addr_dat);
}


/*--------------------------------------------------------------*/ 
//λַ
void LCD_printc(unsigned char x, unsigned char y, unsigned char c)
{
	LCD_pos(x, y);
	LCD_dat(c);
}


/*--------------------------------------------------------------*/ 
//λַ
void LCD_prints(unsigned char x, unsigned char y, unsigned char *s)
{
	LCD_pos(x, y);
	while(*s)
	{
		LCD_dat(*s);
		s++;
	}
}


/*--------------------------------------------------------------*/ 
//λ16λ
// 0<= num <65536
// num_bit	1~5
void LCD_printn(unsigned char x, unsigned char y, unsigned int num, unsigned char num_bit)
{
	signed   char i;
	unsigned char ii;
	unsigned char dat[6];
	for(i = 0; i < 6; i++) dat[i] = 0; i = 0;	//ʼ
	while(num / 10)								//λ
	{
		dat[i] = num % 10;						//λ
		num /= 10; i++;		
	}
	dat[i] = num;								//λ
	ii = i;										//datλ
	for(; i >= 0; i--)	dat[i] += 48;			//תASCII
	for(i = 0; i < num_bit; i++)
		LCD_printc(x++, y, ' ');				//ʾ
	LCD_pos(x, y);
	for(i = ii; i >= 0; i--) LCD_dat(dat[i]);	//ַ
}


/*--------------------------------------------------------------*/ 
//LCDʼ
void LCD_init(void)
{
#if Port_Type_Select			//ѡλģʽ
	LCD_DISPLAY8_DOUBLE_LINE	//LCDΪ16X2ʾ,5X7,λݽӿ
#else
	LCD_DISPLAY4_DOUBLE_LINE	//LCDΪ16X2ʾ,5X7,λݽӿ
#endif
	LCD_AC_AUTO_INCREMENT		//LCDʾƶ(ַָ1,ʾƶ)
	LCD_DISPLAY_ON				//LCDʾ(겻˸,ʾ"_")
	LCD_CLR						//
}


/*--------------------------------------------------------------*/ 
#endif





