	.module _74HC595+8LED_Display.C
	.area lit(rom, con, rel)
_seg::
	.byte 192,249
	.byte 164,176
	.byte 153,146
	.byte 130,248
	.byte 128,144
	.byte 136,131
	.byte 198,161
	.byte 134,142
	.byte 255
	.dbfile F:\ѧϰ\AVRƬ\ҵAVR\ʵM8\\342C4~1.\LEDʾԭ/74HC595.H
	.dbsym e seg _seg A[17:17]kc
_pos::
	.byte 1,2
	.byte 4,8
	.byte 16,32
	.byte 64,128
	.dbsym e pos _pos A[8:8]kc
	.area text(rom, con, rel)
	.dbfile F:\ѧϰ\AVRƬ\ҵAVR\ʵM8\\342C4~1.\LEDʾԭ/74HC595.H
	.dbfunc e Ser_IN _Ser_IN fV
;              i -> R20
;           Data -> R16
	.even
_Ser_IN::
	rcall push_gset1
	.dbline -1
	.dbline 45
; /*--------------------------------------------------------------*/
; //ICC-AVR application builder : 2009-7-22 10:46:10
; // Target : M8
; // Crystal: 1.000Mhz
; // LEDʾ
; /*--------------------------------------------------------------*/
; 
; 
; /*--------------------------------------------------------------*/
; //ͷļ
; #include <iom8v.h>
; #include <macros.h>
; #include "ICCAVRIO.H"		//AVR IOλ
; #include "74HC595.H"		//LED
; 
; 
; 
; /*--------------------------------------------------------------*/
; //ʱ2000-1us 
; //#pragma ctask delay2ms                //ֹĴջջ
; void delay2ms(void)
; {
;         unsigned char i, j = 2;
;         do{i = 248; do{i--;}while(i); j--;}while(j);
; }
; 
; 
; /*--------------------------------------------------------------*/
; void main(void)
; {
; 	unsigned char i;
; 
; 	while(1)
; 	{
; 		for(i = 0; i < 8; i++)
; 		{
; 			Ser_IN(pos[i]);
; 			Ser_IN(seg[i]);
; 			Par_OUT();
; 			delay2ms();			//ӳʱ2ms
; 		}
; 	}
; }
; 
; 
	.dbline 47
; 		
; 		
	clr R20
	rjmp L6
L3:
	.dbline 48
; 		
	.dbline 49
; 		
	in R24,0x14
	ori R24,4
	out 0x14,R24
	.dbline 49
	in R24,0x15
	andi R24,251
	out 0x15,R24
	.dbline 50
; 		
	sbrs R16,7
	rjmp L7
	.dbline 50
	.dbline 50
	in R24,0x14
	ori R24,2
	out 0x14,R24
	.dbline 50
	in R24,0x15
	ori R24,2
	out 0x15,R24
	.dbline 50
	rjmp L8
L7:
	.dbline 51
; 		
	.dbline 51
	in R24,0x14
	ori R24,2
	out 0x14,R24
	.dbline 51
	in R24,0x15
	andi R24,253
	out 0x15,R24
	.dbline 51
L8:
	.dbline 53
	lsl R16
	.dbline 54
	in R24,0x14
	ori R24,4
	out 0x14,R24
	.dbline 54
	in R24,0x15
	ori R24,4
	out 0x15,R24
	.dbline 55
L4:
	.dbline 47
	inc R20
L6:
	.dbline 47
	cpi R20,8
	brlo L3
	.dbline -2
L2:
	rcall pop_gset1
	.dbline 0 ; func end
	ret
	.dbsym r i 20 c
	.dbsym r Data 16 c
	.dbend
	.dbfunc e Par_OUT _Par_OUT fV
	.even
_Par_OUT::
	.dbline -1
	.dbline 62
; 		
; 		
; 		
; 		
; 		
; 		
; 		
; 		
; 		
; 		
; 		
	.dbline 63
; 		
	in R24,0x14
	ori R24,1
	out 0x14,R24
	.dbline 63
	in R24,0x15
	andi R24,254
	out 0x15,R24
	.dbline 64
; 		
	in R24,0x14
	ori R24,1
	out 0x14,R24
	.dbline 64
	in R24,0x15
	ori R24,1
	out 0x15,R24
	.dbline -2
L9:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Ser_Par _Ser_Par fV
;           Data -> R20
	.even
_Ser_Par::
	rcall push_gset1
	mov R20,R16
	.dbline -1
	.dbline 72
; 		
; 		
; 		
; 		
; 		
; 		
; 		
; 		
	.dbline 73
; 		
	mov R16,R20
	rcall _Ser_IN
	.dbline 74
; 		
	rcall _Par_OUT
	.dbline -2
L10:
	rcall pop_gset1
	.dbline 0 ; func end
	ret
	.dbsym r Data 20 c
	.dbend
	.dbfile F:\ѧϰ\AVRƬ\ҵAVR\ʵM8\\342C4~1.\LEDʾԭ\74HC595+8LED_Display.C
	.dbfunc e delay2ms _delay2ms fV
;              j -> R16
;              i -> R18
	.even
_delay2ms::
	.dbline -1
	.dbline 22
	.dbline 23
	ldi R16,2
L12:
	.dbline 24
	.dbline 24
	ldi R18,248
L15:
	.dbline 24
	.dbline 24
	dec R18
	.dbline 24
L16:
	.dbline 24
	tst R18
	brne L15
	.dbline 24
	dec R16
	.dbline 24
L13:
	.dbline 24
	tst R16
	brne L12
	.dbline -2
L11:
	.dbline 0 ; func end
	ret
	.dbsym r j 16 c
	.dbsym r i 18 c
	.dbend
	.dbfunc e main _main fV
;              i -> R20
	.even
_main::
	.dbline -1
	.dbline 30
	rjmp L20
L19:
	.dbline 34
	.dbline 35
	clr R20
	rjmp L25
L22:
	.dbline 36
	.dbline 37
	ldi R24,<_pos
	ldi R25,>_pos
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	lpm R16,Z
	rcall _Ser_IN
	.dbline 38
	ldi R24,<_seg
	ldi R25,>_seg
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	lpm R16,Z
	rcall _Ser_IN
	.dbline 39
	rcall _Par_OUT
	.dbline 40
	rcall _delay2ms
	.dbline 41
L23:
	.dbline 35
	inc R20
L25:
	.dbline 35
	cpi R20,8
	brlo L22
	.dbline 42
L20:
	.dbline 33
	rjmp L19
X0:
	.dbline -2
L18:
	.dbline 0 ; func end
	ret
	.dbsym r i 20 c
	.dbend
