	.module _74HC595+8LED_Display.C
	.area lit(rom, con, rel)
_seg::
	.byte 192,249
	.byte 164,176
	.byte 153,146
	.byte 130,248
	.byte 128,144
	.byte 136,131
	.byte 198,161
	.byte 134,142
	.byte 255
	.dbfile F:\ѧϰ\AVRƬ\ҵAVR\ʵM8\\342C4~1.\LEDˮ/74HC595.H
	.dbsym e seg _seg A[17:17]kc
_pos::
	.byte 1,2
	.byte 4,8
	.byte 16,32
	.byte 64,128
	.dbsym e pos _pos A[8:8]kc
	.area text(rom, con, rel)
	.dbfile F:\ѧϰ\AVRƬ\ҵAVR\ʵM8\\342C4~1.\LEDˮ/74HC595.H
	.dbfunc e Ser_IN _Ser_IN fV
;              i -> R20
;           Data -> R16
	.even
_Ser_IN::
	rcall push_gset1
	.dbline -1
	.dbline 45
; /*--------------------------------------------------------------*/
; //ICC-AVR application builder : 2009-7-22 10:46:10
; // Target : M8
; // Crystal: 1.000Mhz
; // LEDһλʾ
; /*--------------------------------------------------------------*/
; 
; 
; /*--------------------------------------------------------------*/
; //ͷļ
; #include <iom8v.h>
; #include <macros.h>
; #include "ICCAVRIO.H"		//AVR IOλ
; #include "74HC595.H"		//LED
; 
; 
; 
; /*-------------------------------------------------------------*/
; //#pragma ctask delay200ms              //ֹĴջջ
; void delay200ms(void)
; {
;         unsigned char x, y, z = 78;
;         do{y = 160; do{x = 3; do{x--;}while(x); y--;}while(y); z--;}while(z);
; }
; 
; 
; /*---------------------------------------------*/
; void main(void)
; {
; 	unsigned char i;
; 	
; 	while(1)
; 	{
; 		for(i = 0; i < 8; i++)
; 		{
; 			Ser_IN(0x01 << i);	//pos
; 			Ser_IN(0x7F);		//seg
; 			Par_OUT();
; 			delay200ms();		//ӳʱ
; 		}
; 	}
; }
; 
; 
; 		
	.dbline 47
; 		
; 		
	clr R20
	rjmp L6
L3:
	.dbline 48
; 		
	.dbline 49
; 		
	in R24,0x14
	ori R24,4
	out 0x14,R24
	.dbline 49
	in R24,0x15
	andi R24,251
	out 0x15,R24
	.dbline 50
; 		
	sbrs R16,7
	rjmp L7
	.dbline 50
	.dbline 50
	in R24,0x14
	ori R24,2
	out 0x14,R24
	.dbline 50
	in R24,0x15
	ori R24,2
	out 0x15,R24
	.dbline 50
	rjmp L8
L7:
	.dbline 51
; 		
	.dbline 51
	in R24,0x14
	ori R24,2
	out 0x14,R24
	.dbline 51
	in R24,0x15
	andi R24,253
	out 0x15,R24
	.dbline 51
L8:
	.dbline 53
	lsl R16
	.dbline 54
	in R24,0x14
	ori R24,4
	out 0x14,R24
	.dbline 54
	in R24,0x15
	ori R24,4
	out 0x15,R24
	.dbline 55
L4:
	.dbline 47
	inc R20
L6:
	.dbline 47
	cpi R20,8
	brlo L3
	.dbline -2
L2:
	rcall pop_gset1
	.dbline 0 ; func end
	ret
	.dbsym r i 20 c
	.dbsym r Data 16 c
	.dbend
	.dbfunc e Par_OUT _Par_OUT fV
	.even
_Par_OUT::
	.dbline -1
	.dbline 62
; 		
; 		
; 		
; 		
; 		
; 		
; 		
; 		
; 		
; 		
; 		
	.dbline 63
; 		
	in R24,0x14
	ori R24,1
	out 0x14,R24
	.dbline 63
	in R24,0x15
	andi R24,254
	out 0x15,R24
	.dbline 64
; 		
	in R24,0x14
	ori R24,1
	out 0x14,R24
	.dbline 64
	in R24,0x15
	ori R24,1
	out 0x15,R24
	.dbline -2
L9:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Ser_Par _Ser_Par fV
;           Data -> R20
	.even
_Ser_Par::
	rcall push_gset1
	mov R20,R16
	.dbline -1
	.dbline 72
; 		
; 		
; 		
; 		
; 		
; 		
; 		
; 		
	.dbline 73
; 		
	mov R16,R20
	rcall _Ser_IN
	.dbline 74
; 		
	rcall _Par_OUT
	.dbline -2
L10:
	rcall pop_gset1
	.dbline 0 ; func end
	ret
	.dbsym r Data 20 c
	.dbend
	.dbfile F:\ѧϰ\AVRƬ\ҵAVR\ʵM8\\342C4~1.\LEDˮ\74HC595+8LED_Display.C
	.dbfunc e delay200ms _delay200ms fV
;              z -> R16
;              y -> R18
;              x -> R20
	.even
_delay200ms::
	rcall push_gset1
	.dbline -1
	.dbline 21
	.dbline 22
	ldi R16,78
L12:
	.dbline 23
	.dbline 23
	ldi R18,160
L15:
	.dbline 23
	.dbline 23
	ldi R20,3
L18:
	.dbline 23
	.dbline 23
	dec R20
	.dbline 23
L19:
	.dbline 23
	tst R20
	brne L18
	.dbline 23
	dec R18
	.dbline 23
L16:
	.dbline 23
	tst R18
	brne L15
	.dbline 23
	dec R16
	.dbline 23
L13:
	.dbline 23
	tst R16
	brne L12
	.dbline -2
L11:
	rcall pop_gset1
	.dbline 0 ; func end
	ret
	.dbsym r z 16 c
	.dbsym r y 18 c
	.dbsym r x 20 c
	.dbend
	.dbfunc e main _main fV
;              i -> R20
	.even
_main::
	.dbline -1
	.dbline 29
	rjmp L23
L22:
	.dbline 33
	.dbline 34
	clr R20
	rjmp L28
L25:
	.dbline 35
	.dbline 36
	ldi R16,1
	mov R17,R20
	rcall lsl8
	rcall _Ser_IN
	.dbline 37
	ldi R16,127
	rcall _Ser_IN
	.dbline 38
	rcall _Par_OUT
	.dbline 39
	rcall _delay200ms
	.dbline 40
L26:
	.dbline 34
	inc R20
L28:
	.dbline 34
	cpi R20,8
	brlo L25
	.dbline 41
L23:
	.dbline 32
	rjmp L22
X0:
	.dbline -2
L21:
	.dbline 0 ; func end
	ret
	.dbsym r i 20 c
	.dbend
