/*--------------------------------------------*/
//Tool: ICCAVR
//Note: 74HC595
//File: 74HC595.H
//Date: 08-7-16
//Time: 8:50
//      __                   __
//Note: MR λӵԴ, OE ʹܶ,ЧӵԴ


/*--------------------------------------------*/
#ifndef __74HC595_H__
#define __74HC595_H__



/*--------------------------------------------*/
#define SD_DS	PORT(C, 1)	//
#define SH_CK	PORT(C, 2)	//λĴʱ
#define ST_CK	PORT(C, 0)	//洢Ĵʱ



/*--------------------------------------------*/
//ܶλĶ
/*--------------------------------------------*/
//ܶλĶ
const unsigned char seg[]={0xc0,0xf9,0xa4,0xb0,0x99,0x92,0x82,0xf8,0x80,0x90,0x88,0x83,0xc6,0xa1,0x86,0x8e,0xff};
                          //0   1    2    3    4    5    6    7    8    9    a    b    c     d    e     f   
const unsigned char pos[]={0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80};
                          //1    2    3   4    5    6     7   8


/*--------------------------------------------*/
//
void Ser_IN(unsigned char Data);	//
void Par_OUT(void);					//
void Ser_Par(unsigned char Data);	//,



/*--------------------------------------------*/
//
void Ser_IN(unsigned char Data)
{
	unsigned char i;
	for(i = 0; i < 8; i++)
	{
		SH_CK = 0;			//CLOCK_MAX=100MHz
	 if(Data & 0x80) {SD_DS = 1;}
	 else 			{SD_DS = 0;}
//		SD_DS = (Data & 0x80) >> 7;
		Data <<= 1;
		SH_CK = 1;
	}
}


/*--------------------------------------------*/
//
void Par_OUT(void)
{
	ST_CK = 0;
	ST_CK = 1;
}



/*--------------------------------------------*/
//,
void Ser_Par(unsigned char Data)
{
	Ser_IN(Data);
	Par_OUT();
}



/*--------------------------------------------*/
#endif 