/*--------------------------------------------*/
//Tool: ICCAVR
//Note: 74HC595
//File: 74HC595.H
//Date: 08-7-16
//Time: 8:50
//      __                   __
//Note: MR λӵԴ, OE ʹܶ,ЧӵԴ


/*--------------------------------------------*/
#ifndef __74HC595_H__
#define __74HC595_H__



/*--------------------------------------------*/
#define SD_DS	PORT(C, 1)	//
#define SH_CK	PORT(C, 2)	//λĴʱ
#define ST_CK	PORT(C, 0)	//洢Ĵʱ



/*--------------------------------------------*/
//ܶλĶ
const unsigned char seg[]={
        0x3F,/*0*/
        0x06,/*1*/
        0x5B,/*2*/
        0x4F,/*3*/
        0x66,/*4*/
        0x6D,/*5*/
        0x7D,/*6*/
        0x07,/*7*/
        0x7F,/*8*/
        0x6F,/*9*/
        0x77,/*A*/
        0x7C,/*b*/
        0x39,/*C*/
        0x5E,/*d*/
        0x79,/*E*/
        0x71,/*F*/
        0x76,/*H*/
        0x74,/*h*/
        0x38,/*L*/
        0x37,/*N*/
        0x5C,/*o*/
        0x73,/*P*/
        0x40/*-*/
};


/*--------------------------------------------*/
//
void Ser_IN(unsigned char Data);	//
void Par_OUT(void);					//
void Ser_Par(unsigned char Data);	//,



/*--------------------------------------------*/
//
void Ser_IN(unsigned char Data)
{
	unsigned char i;
	for(i = 0; i < 8; i++)
	{
		SH_CK = 0;			//CLOCK_MAX=100MHz
		if(Data & 0x80) {SD_DS = 1;}
		else 			{SD_DS = 0;}
//		SD_DS = (Data & 0x80) >> 7;
		Data <<= 1;
		SH_CK = 1;
	}
}


/*--------------------------------------------*/
//
void Par_OUT(void)
{
	ST_CK = 0;
	ST_CK = 1;
}



/*--------------------------------------------*/
//,
void Ser_Par(unsigned char Data)
{
	Ser_IN(Data);
	Par_OUT();
}



/*--------------------------------------------*/
#endif 